/*
-------------------------------------------------------------------------------
    This file is a part of the VST Preset Generator
    Copyright (C) 2007  Francois Mazen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-------------------------------------------------------------------------------
  Name: vpgfile.h
  Author: Francois Mazen
  Date: 28/06/16 19:22
  Description: VpgFile class that represent the list of VST plugins and presets
               loaded by the user.
-------------------------------------------------------------------------------
*/

#ifndef VPGFILE_H
#define VPGFILE_H

#include <QString>

class VSTListModel;

class VpgFile
{
public:
    enum ERROR_CODE
    {
        ERROR_NO_ERROR,
        ERROR_COULD_NOT_OPEN_FILE,
        ERROR_COULD_NOT_PARSE_FILE,
        ERROR_INVALID_VPG_FILE,
        ERROR_UNKNOWN_XML_TAG,
        ERROR_INVALID_XML_ELEMENT
    };

    static VpgFile::ERROR_CODE ReadFile(const QString& filename, VSTListModel& vstListModel);
    static VpgFile::ERROR_CODE WriteFile(const QString& filename, const VSTListModel& vstListModel);
};

#endif // VPGFILE_H
